/*
CC BY-NC-SA
(c) 2012 Sascha Kloß

Beispiel-Sketch für die BSB-Arduino-Library
---
BSB ist ein Feldbus von Siemens vornehmlich für Heizungssteuerungen.
Verwendet wird dieser u.a. bei Brötje Heizungen mit Siemens Steuerungen.

Aufbau:
- Arduino UNO
- Je einen 2.2k und 1.5k Widerstand
- Etwas Kabel

Der Arduino wird wiefolgt verkabelt:
 CL+
  |
  |
------
|2.2k|
------
  |
  |
   > (ANALOG 3/PIN 17) 
  |
  |
------
|1.5k|
------
  |
  |
 CL- --- GND

Am Bediengerät /AVS37 gibt es vorn eine Service Buchse hinter einem
Gummi-Profen links neben dem Display. Hierbei ist die Belegung wiefolgt (von oben):
1  +12V
2  CL+
3  CL-
4 

Details: http://www.mikrocontroller.net/topic/218643
*/

#include <SoftwareSerial.h>
#include <bsb.h>

BSB bus(17,14);

void setup() {
  Serial.begin(9600);
}
  
void loop() {
  BSB_MESSAGE msg;
  
  if (bus.waitForMessage(&msg)) {
    Serial.println("GOT MESSAGE");
    if (bus.parse(&msg)) {
      Serial.print("Room:    ");
      Serial.println(bus.T_Room);
      
      Serial.print("Outside: ");
      Serial.println(bus.T_Outside);
      }

      Serial.println();
  }
}
