/*
CC BY-NC-SA
(c) 2012 Sascha Kloß

http://www.mikrocontroller.net/topic/218643
*/
#ifndef __BSB_H__
#define __BSB_H__

//Now the library is compatible both with Arduino <=0023 and Arduino >=100
#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif

#include "SoftwareSerial.h"

// See this page for further details:
// http://www.mikrocontroller.net/topic/218643
typedef struct
{
  byte SRC;
  byte RCV;

  byte LEN;

  byte TYP1;

  byte U1;
  byte U2;

  byte A1;
  byte A2;
  
  byte DATA[14];
} BSB_MESSAGE;


enum HEAT_STATE {
  off,
  locked,
  jammed,
  unfreezing,
  antifreeze,
  heating,
  waittime
};

class BSB
{
public:
  BSB(uint8_t rx, uint8_t tx);
  bool waitForMessage(BSB_MESSAGE* msg);
  bool parse(BSB_MESSAGE* msg);
  bool receive(BSB_MESSAGE* msg);
  bool send(BSB_MESSAGE* msg);
  double T_Outside, T_Puffer, T_Water, T_Flow, T_Room;
  HEAT_STATE state;

private:
  double GetTempFromData(BSB_MESSAGE* msg, byte DataIndex);
  
  
  SoftwareSerial* serial;
};

#endif

